package com.maroontress.sanctuary;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
   DTDΥƥIDǤ
*/
public final class SystemID {

    /** ᥸㡼С */
    private int majorVersion;

    /** ޥʡС */
    private int minorVersion;

    /** ƥIDΥѥ */
    private static final Pattern SYSTEM_ID;

    static {
	SYSTEM_ID = Pattern.compile("http://maroontress\\.com/Sanctuary/"
				    + "(0|[1-9][0-9]*)\\.(0|[1-9][0-9]*)"
				    + "/sanctuary\\.dtd");
    }

    /**
       DTDΥƥIDޤ

       @param majorVersion ƥIDΥ᥸㡼С
       @param minorVersion ƥIDΥޥʡС
    */
    private SystemID(final int majorVersion, final int minorVersion) {
	this.majorVersion = majorVersion;
	this.minorVersion = minorVersion;
    }

    /**
       ƥIDΥ᥸㡼Сޤ

       @return ᥸㡼С
    */
    public int getMajorVersion() {
	return majorVersion;
    }

    /**
       ƥIDΥޥʡСޤ

       @return ޥʡС
    */
    public int getMinorVersion() {
	return minorVersion;
    }

    /**
       ʸѡƥƥIDޤ

       @param s ƥIDɽʸ
       @return ƥIDޤnull
    */
    public static SystemID parse(final String s) {
	Matcher m = SYSTEM_ID.matcher(s);
	if (!m.matches()) {
	    return null;
	}
	int major = Integer.parseInt(m.group(1));
	int minor = Integer.parseInt(m.group(2));
	return new SystemID(major, minor);
    }
}
